// DlgDebug.cpp : ʵļ
//

#include "stdafx.h"
#include "OGCAssistTool.h"
#include "PageDebug.h"
#include "Injection.h"
#include "CharEncoding.h"

// ע;
extern CInjection g_Injection;
// OGC Tool;
extern HWND g_hWnd_SN;
extern HWND g_hWnd_SN_Combobox;
extern HWND g_hWnd_Tester;
extern HWND g_hWnd_FWVersion;
extern HWND g_hWnd_Channel;
extern BOOL StartOGCTool();
DWORD CPageDebug::m_dwGoProcThreadId=0;
// CDlgDebug Ի

#define COLOR_RED RGB(255,0,0)
#define COLOR_GREED RGB(0,255,0)

CPageDebug *CPageDebug::m_pDlg = NULL;
IMPLEMENT_DYNAMIC(CPageDebug, CDialogEx)

CPageDebug::CPageDebug(CWnd* pParent /*=NULL*/)
	: CDialogEx(CPageDebug::IDD, pParent)
{
	m_pDlg = this;
}

CPageDebug::~CPageDebug()
{
}

void CPageDebug::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, LIST_DEBUG_DATA, m_ctrlList);
	DDX_Control(pDX, BTN_CONNECT, m_btnConnect);
	DDX_Control(pDX, COMBO_ETYPE, m_cbDeltaEType);
}


BEGIN_MESSAGE_MAP(CPageDebug, CDialogEx)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(BTN_SHOW_WND, &CPageDebug::OnBnClickedShowWnd)
	ON_BN_CLICKED(CHECK_HIJACK, &CPageDebug::OnBnClickedHijack)
	ON_BN_CLICKED(BTN_TEST, &CPageDebug::OnBnClickedTest)
	ON_BN_CLICKED(BTN_CONNECT, &CPageDebug::OnBnClickedConnect)
	ON_WM_TIMER()
	ON_BN_CLICKED(CHECK_LOCK, &CPageDebug::OnBnClickedLock)
	ON_BN_CLICKED(BTN_LOAD_DATA, &CPageDebug::OnBnClickedLoadData)
	ON_CBN_SELCHANGE(COMBO_ETYPE, &CPageDebug::OnCbnSelchangeEtype)
END_MESSAGE_MAP()


// CDlgDebug Ϣ

BOOL CPageDebug::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  ڴӶĳʼ
	//SetBackgroundColor(RGB(255,255,255));
	SetBackgroundColor(RGB(200,200,200));
	InitListCtrl();

	if ( !GLOBAL::g_config.nOffline )
	{
		// ģʽ;
		GetDlgItem(COMBO_ETYPE)->EnableWindow(FALSE);
		GetDlgItem(EDIT_EVALUE)->EnableWindow(FALSE);
		GetDlgItem(SPIN_EVALUE)->EnableWindow(FALSE);
	}
	else
	{
		// ģʽ;
		CRect rcBtn;
		CRect rcEdit;
		GetDlgItem(BTN_LOAD_DATA)->GetWindowRect(&rcBtn);
		GetDlgItem(EDIT_BATCH_NUMBER)->GetWindowRect(&rcEdit);
		GetDlgItem(BTN_LOAD_DATA)->ShowWindow(FALSE);
		//GetDlgItem(EDIT_BATCH_NUMBER)->ClientToScreen(rcEdit);
		//GetDlgItem(EDIT_BATCH_NUMBER)->MoveWindow(rcEdit.left, rcEdit.top, rcEdit.Width()+rcBtn.Width(), rcEdit.Height(), TRUE);
		GetDlgItem(EDIT_BATCH_NUMBER)->SetWindowPos(NULL, rcEdit.left, rcEdit.top, rcEdit.Width()+rcBtn.Width(), rcEdit.Height(), SWP_NOZORDER|SWP_NOMOVE);

		TCHAR szValue[8] = {0};
		SetDlgItemText(EDIT_EVALUE, GLOBAL::g_config.szDeltaEValue);
		SetDlgItemText(EDIT_BATCH_NUMBER, GLOBAL::g_config.szBatchNumber);
		((CComboBox*)GetDlgItem(COMBO_ETYPE))->SetCurSel(GLOBAL::g_config.nDeltaEType);
	}

	m_btnConnect.SetFaceColor(COLOR_RED);
	GLOBAL::g_IOCP.SetCallBack(NULL, NULL, NULL, ReceiveProc);
	SetDlgItemText(EDIT_LINE, GLOBAL::g_config.szLine);

	HANDLE hThread = CreateThread(NULL, 0, ThreadGoProc, this, 0, &m_dwGoProcThreadId);
	if ( hThread )
		CloseHandle(hThread);

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}

HBRUSH CPageDebug::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialogEx::OnCtlColor(pDC, pWnd, nCtlColor);

	// TODO:  ڴ˸ DC κ
	switch ( pWnd->GetDlgCtrlID() ) 
	{
	case CHECK_LOCK:
	case CHECK_HIJACK:
		{
#if 1 // ͸ؼ;
			pDC->SetBkMode(TRANSPARENT);

			CRect rc;
			pWnd->GetWindowRect(&rc);
			ScreenToClient(&rc);

			CDC* dc = GetDC();
			pDC->BitBlt(0,0,rc.Width(),rc.Height(),dc,rc.left,rc.top,SRCCOPY);  //ѸڱͼƬȻť

			ReleaseDC(dc);
			hbr = (HBRUSH) ::GetStockObject(NULL_BRUSH);
#endif
		}
		break;
	default:
		break; 
	}

	// TODO:  ĬϵĲ軭ʣ򷵻һ
	return hbr;
}

void CPageDebug::InitListCtrl()
{
	m_ctrlList.InsertColumn( 0, _T(""));
	m_ctrlList.SetColumnWidth( 0, 50 );
	m_ctrlList.InsertColumn( 1, _T("R"));
	m_ctrlList.SetColumnWidth( 1, 100 );
	m_ctrlList.InsertColumn( 2, _T("G"));
	m_ctrlList.SetColumnWidth( 2, 100);
	m_ctrlList.InsertColumn( 3, _T("B"));
	m_ctrlList.SetColumnWidth( 3, 100);
	m_ctrlList.InsertColumn( 4, _T("Eʵֵ"));
	m_ctrlList.SetColumnWidth(4, 100);
}

HWND MyFindWindow(LPCTSTR lpClassName)
{
	HWND hWnd = NULL;
	if ( lpClassName == NULL || lpClassName[0] == '\0' )
		return hWnd;

	for (std::vector<GLOBAL::WND_INFO>::iterator it = GLOBAL::g_procWndInfo.vtWndInfo.begin(); it != GLOBAL::g_procWndInfo.vtWndInfo.end(); it++ )
	{
		// صһҵ;
		if ( _tcscmp(lpClassName, it->szClassName) == 0 )
		{
			hWnd = it->hWnd;
			break;
		}
	}

	return hWnd;
}

BOOL CPageDebug::ConnectProc(DATAHEADER *pHeader, MSG_INFO *pMsg)
{
	if ( m_pDlg == NULL )
		return FALSE;

	static DATAHEADER header;
	header=*pHeader;
	static MSG_INFO msg;
	msg=*pMsg;
	PostThreadMessage(m_dwGoProcThreadId, WM_CONNECT_PRO, (WPARAM)&header, (LPARAM)&msg);

	/*
	if ( pHeader->byMsgType == C2S_CONNECT )
		m_pDlg->SetDlgItemText(BTN_CONNECT, pMsg->byResult ? _T("Ͽ") : _T("豸"));
	else if ( pHeader->byMsgType == C2S_DISCONNECT )
		m_pDlg->SetDlgItemText(BTN_CONNECT, pMsg->byResult ? _T("豸") : _T("Ͽ"));
	*/
}

BOOL CPageDebug::ReceiveProc(DATAHEADER *pHeader, MSG_INFO *pMsg)
{
	if ( !pHeader || !pMsg )
		return FALSE;

	DATAHEADER header=*pHeader;
	MSG_INFO msg_info=*pMsg;

	switch( header.byMsgType )
	{
	case C2S_HIJACK:
		{
			static MSG_INFO msg;
			static DATAHEADER header;			
			msg=*pMsg;
			header=*pHeader;
			dprintf(_T("յͻϢٳ"));
			PostThreadMessage(m_dwGoProcThreadId, C2S_HIJACK, (WPARAM)&header, (LPARAM)&msg);
		}
		break;
	case C2S_RESUME:
		{
			static MSG_INFO msg;
			static DATAHEADER header;			
			msg=*pMsg;
			header=*pHeader;
			dprintf(_T("յͻϢָ"));
			PostThreadMessage(m_dwGoProcThreadId, C2S_RESUME, (WPARAM)&header, (LPARAM)&msg);
		}
		break;
	case C2S_CONNECT:
		{
			static MSG_INFO msg;
			static DATAHEADER header;			
			msg=*pMsg;
			header=*pHeader;
			dprintf(_T("յͻϢ"));
			PostThreadMessage(m_dwGoProcThreadId, C2S_CONNECT, (WPARAM)&header, (LPARAM)&msg);
		}
		break;
	case C2S_DISCONNECT:
		{
			static MSG_INFO msg;
			static DATAHEADER header;			
			msg=*pMsg;
			header=*pHeader;
			dprintf(_T("յͻϢϿ"));
			PostThreadMessage(m_dwGoProcThreadId, C2S_DISCONNECT, (WPARAM)&header, (LPARAM)&msg);
		}
		break;
	case C2S_CHECKFW:
		{
			static MSG_INFO msg;
			static DATAHEADER header;			
			msg=*pMsg;
			header=*pHeader;
			dprintf(_T("յͻϢCheckFW"));
			PostThreadMessage(m_dwGoProcThreadId, C2S_CHECKFW, (WPARAM)&header, (LPARAM)&msg);
		}
		break;
	case C2S_EXCEPTION:
		{
			static MSG_INFO msg;
			static DATAHEADER header;			
			msg=*pMsg;
			header=*pHeader;
			dprintf(_T("յͻϢ쳣"));
			PostThreadMessage(m_dwGoProcThreadId, C2S_EXCEPTION, (WPARAM)&header, (LPARAM)&msg);
		}
		break;
	case C2S_GO:
		{
			static MSG_INFO msg;
			static DATAHEADER header;			
			msg=*pMsg;
			header=*pHeader;
			dprintf(_T("յͻϢGo"));
			PostThreadMessage(m_dwGoProcThreadId, C2S_GO, (WPARAM)&header, (LPARAM)&msg);			
		}
		break;
	case C2S_COMMUNICATION_ERROR:
		{
			static MSG_INFO msg;
			static DATAHEADER header;			
			msg=*pMsg;
			header=*pHeader;
			dprintf(_T("յͻϢͨŴ"));
			PostThreadMessage(m_dwGoProcThreadId, C2S_COMMUNICATION_ERROR, (WPARAM)&header, (LPARAM)&msg);
		}
		break;
	default:
		break;
	}

	return FALSE;
}

DWORD CPageDebug::ThreadGoProc(LPVOID lpParam)
{
	MSG msg;
	CPageDebug* pDlg = (CPageDebug*)lpParam;
	while (::GetMessage(&msg, NULL, 0, 0))
	{
		switch (msg.message)
		{
		case C2S_HIJACK:
			{
				DATAHEADER &header = *(DATAHEADER*)msg.wParam;
				MSG_INFO &msg_info = *(MSG_INFO*)msg.lParam;

				if ( msg_info.byResult )
				{
					GLOBAL::g_procWndInfo.bHijackStatus = TRUE;
					((CButton*)m_pDlg->GetDlgItem(CHECK_HIJACK))->SetCheck(TRUE);
				}
			}
			break;
		case C2S_RESUME:
			{
				DATAHEADER &header = *(DATAHEADER*)msg.wParam;
				MSG_INFO &msg_info = *(MSG_INFO*)msg.lParam;
				if ( msg_info.byResult )
				{
					GLOBAL::g_procWndInfo.bHijackStatus = FALSE;
					((CButton*)m_pDlg->GetDlgItem(CHECK_HIJACK))->SetCheck(FALSE);
				}
			}
			break;
		case C2S_CONNECT:
			{
				DATAHEADER &header = *(DATAHEADER*)msg.wParam;
				MSG_INFO &msg_info = *(MSG_INFO*)msg.lParam;
				GLOBAL::g_procWndInfo.bConnectStatus = msg_info.byResult;
				m_pDlg->SetDlgItemText(BTN_CONNECT, msg_info.byResult ? _T("Ͽ") : _T("豸"));
				m_pDlg->m_btnConnect.SetFaceColor(msg_info.byResult ? COLOR_GREED : COLOR_RED);
			}
			break;
		case C2S_DISCONNECT:
			{
				DATAHEADER &header = *(DATAHEADER*)msg.wParam;
				MSG_INFO &msg_info = *(MSG_INFO*)msg.lParam;
				GLOBAL::g_procWndInfo.bConnectStatus = !msg_info.byResult;
				m_pDlg->SetDlgItemText(BTN_CONNECT, msg_info.byResult ? _T("豸") : _T("Ͽ"));
				m_pDlg->m_btnConnect.SetFaceColor(msg_info.byResult ? COLOR_RED : COLOR_GREED);
			}
			break;
		case C2S_GO:
			{
				DATAHEADER &header = *(DATAHEADER*)msg.wParam;
				MSG_INFO &msg_info = *(MSG_INFO*)msg.lParam;
				// ȡʱ;
				DWORD dwElapsed = _tstol((TCHAR*)msg_info.byData);
				// ȡConfig.dat;
				TCHAR szConfigPath[MAX_PATH] = {0};
				_stprintf_s(szConfigPath, _T("%s\\Config.dat"), GLOBAL::g_config.szOGCToolPath);
				if ( PathFileExists(szConfigPath) )
				{
					CFile file;
					CFileException excep;
					if ( file.Open(szConfigPath, CFile::modeRead, &excep) )
					{
						DWORD dwRead = 0;
						DWORD dwCount = 0;
						string strData;
						char szRead[MAX_PATH] = {0};
						DWORD dwLen = file.GetLength();
						while ( dwCount < dwLen )
						{
							dwRead = file.Read(szRead, MAX_PATH);
							strData.append(szRead, dwRead);
							dwCount += dwRead;
						}

						file.Close();

						// ȡ;
						int nPos=0;
						int nIndex = 0;
						while ( (nPos=strData.find('\r\n')) != std::string::npos )
						{
							if ( nIndex++ == 6 )
							{
								strData = strData.substr(0, nPos);
								break;
							}
							strData = strData.substr(nPos+2);				
						}

						// ļcvs·;
						CString strSN;
						m_pDlg->GetDlgItemText(EDIT_SN, strSN);
						TCHAR szOutDataPath[MAX_PATH] = {0};
						_stprintf_s(szOutDataPath, _T("%s\\Output_%s_%s\\%s\\sRGB_32Patterns_.csv"), GLOBAL::g_config.szOGCToolPath, CharEncoding::ASCII2UNICODE(strData.c_str()), CTime::GetCurrentTime().Format("%Y%m%d").GetString(), strSN.GetString());
						if ( PathFileExists(szOutDataPath) )
						{
							// ļ,жȡ;
							std::string strFileData = GLOBAL::GetFileData(szOutDataPath);
							if ( strFileData.size() )
							{
								std::vector<std::string> vtList;
								GLOBAL::GetStringList(strFileData, "\r\n", vtList);
								if ( vtList.size() )
								{
									DOUBLE dAVGValue = 0.0;
									std::vector<GLOBAL::RGB_PAT> vtRGB;
									GLOBAL::CheckOutData(vtList, vtRGB);
									if ( vtRGB.size() )
									{
										BOOL bRet = GLOBAL::IsDebugPass(vtRGB, GLOBAL::g_config.nDeltaEType, GLOBAL::g_config.dDeltaEValue, dAVGValue);
										if ( bRet )
										{

										}
										else
										{

										}
									}
								}
							}
						}
					}
				}

				m_pDlg->GetDlgItem(BTN_TEST)->EnableWindow(TRUE);
			}
			break;
		default:
			break;
		}
	}
	return 0;
}

void CPageDebug::OnBnClickedShowWnd()
{
	// TODO: ڴӿؼ֪ͨ
	CString strText;
	GetDlgItemText(BTN_SHOW_WND, strText);
	if ( strText == _T("ʾ") )
	{
		ShowOGCWnd(SW_SHOW);
	}
	else
	{
		ShowOGCWnd(SW_HIDE);
	}
}

void CPageDebug::OnBnClickedHijack()
{
	// TODO: ڴӿؼ֪ͨ
	BOOL bCheck = ((CButton*)GetDlgItem(CHECK_HIJACK))->GetCheck();
	if ( bCheck )
	{
		// ٳִ;
		MSG_INFO msg;
		DATAHEADER header;
		header.byMsgType = S2C_HIJACK;
		GLOBAL::g_IOCP.SendPackage(header, msg);
#ifdef _DEBUG
		MessageBox(_T("ٳִ"), _T("ʾ"), MB_OK);
#endif
	}
	else
	{
		// ָ;
		MSG_INFO msg;
		DATAHEADER header;
		header.byMsgType = S2C_RESUME;
		GLOBAL::g_IOCP.SendPackage(header, msg);
#ifdef _DEBUG
		MessageBox(_T("ָ"), _T("ʾ"), MB_OK);
#endif
	}
}

void CPageDebug::OnBnClickedTest()
{
	if ( GLOBAL::g_procWndInfo.bHijackStatus && GLOBAL::g_procWndInfo.bConnectStatus )
	{
		CString strSN;
		CString strOrderID;
		CString strDeltaEValue;
		GetDlgItemText(EDIT_SN, strSN);
		GetDlgItemText(EDIT_BATCH_NUMBER, strOrderID);
		GetDlgItemText(EDIT_EVALUE, strDeltaEValue);

		if ( strOrderID.IsEmpty() )
		{
			MessageBox(_T("󣺶Ųܿգ붩ţ"), _T(""), MB_ICONERROR);
			return;
		}

		if ( ((CComboBox*)GetDlgItem(COMBO_ETYPE))->GetCurSel() == CB_ERR )
		{
			MessageBox(_T("δѡָDeltaEͣ"), _T(""), MB_ICONERROR);
			return;
		}

		if ( strDeltaEValue.IsEmpty() )
		{
			MessageBox(_T("DeltaE׼ֵܿգDeltaE׼ֵ"), _T(""), MB_ICONERROR);
			return;
		}

		if ( GLOBAL::IsDigitString(strDeltaEValue) == -1 )
		{
			MessageBox(_T("DeltaE׼ֵ֣֣"), _T(""), MB_ICONERROR);
			return;
		}

		if ( strSN.IsEmpty() )
		{
			MessageBox(_T("SNܿգSN"), _T(""), MB_ICONERROR);
			return;
		}

		if ( strSN.GetLength() > 25 )
		{
			MessageBox(_T("SNȲܳ25"), _T(""), MB_ICONERROR);
			return;
		}

		// SN򳤶;
		if ( g_hWnd_SN_Combobox )
		{
			TCHAR szLen[10] = {0};
			_ltot_s(strSN.GetLength(), szLen, 10, 10);
			::SendMessage(g_hWnd_SN_Combobox, CB_SELECTSTRING, 0, (LPARAM)&szLen);	// ˷þıɹ;
		}

		// SN༭;
		if ( g_hWnd_SN )
		{
			TCHAR szSN[26] = {0};
			_stprintf_s(szSN, _T("%s"), strSN.GetString());
			::SendMessage(g_hWnd_SN, WM_SETTEXT, 0, (LPARAM)&szSN);
		}

		// ťGoť;
		HWND hWnd = GLOBAL::g_procWndInfo.GetButtonWnd(_T("Go"));
		if ( hWnd )
		{
			::PostMessage(hWnd, WM_LBUTTONDOWN, 0, 0);
			Sleep(50);
			::PostMessage(hWnd, WM_LBUTTONUP, 0, 0);
		}

		GetDlgItem(BTN_TEST)->EnableWindow(FALSE);
		//SetTimer(1, 500, NULL);
	}
	else
	{
		MessageBox(_T("δ豸Ȱ豸ť"), _T("ʾ"), MB_ICONWARNING);
	}
}

void CPageDebug::OnBnClickedConnect()
{
	CString strText;
	GetDlgItemText(BTN_CONNECT, strText);
	if ( strText == _T("豸") )
	{
		// 1ִһConnectť¼;
		//// 1.1Connectɹ, Ŀ̻᷵Ϣ;
		//// 1.2ûϢأҪжǷڳǰעConnect
		//// 1.3Ҫ2ӦÿʱĿ̷Ϣȡť״̬
		// 2ȡSN,һSN;
		// 3SNֵĿSN༭;
		// 4ִGo;
		// 5ٳֵGoδϢʱ,TestťSN༭ֹ;
		switch ( StartOGCTool() )
		{
		case -1:
			// ˳¿;
			break;
		case 0:
			// ¿ʧ;
			break;
		case 1:
			// ¿ɹ;
			{
				AfxGetApp()->GetMainWnd()->SetTimer(0, 500, NULL);
				MessageBox(_T("OGCУԺٳԣлл"), _T("ʾ"), MB_OK|MB_ICONWARNING);
			}
			break;
		case 2:
			// Ѵڽ;
			{
				// ִConnectť;
				if ( GLOBAL::g_procWndInfo.bHijackStatus && !GLOBAL::g_procWndInfo.bConnectStatus )
				{
					HWND hWnd = GLOBAL::g_procWndInfo.GetButtonWnd(_T("Connect CA310"));
					if ( hWnd )
					{
						::PostMessage(hWnd, WM_LBUTTONDOWN, 0, 0);
						Sleep(50);
						::PostMessage(hWnd, WM_LBUTTONUP, 0, 0);
					}

					SetDlgItemText(BTN_CONNECT, _T("С"));
					//SetTimer(0, 500, NULL);
				}
				else
				{
					MessageBox(_T("豸ӳɹ~"), _T("ʾ"), MB_OK);
					SetDlgItemText(BTN_CONNECT, _T("Ͽ豸"));
					m_btnConnect.SetFaceColor(COLOR_GREED);
				}
			}
			break;
		default:
			break;
		}
	}
	else
	{
		HWND hWnd = GLOBAL::g_procWndInfo.GetButtonWnd(_T("Disconnect"));
		if ( hWnd )
		{
			::PostMessage(hWnd, WM_LBUTTONDOWN, 0, 0);
			Sleep(50);
			::PostMessage(hWnd, WM_LBUTTONUP, 0, 0);
		}

		SetDlgItemText(BTN_CONNECT, _T("豸"));
	}	
}

void CPageDebug::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ڴϢ/Ĭֵ
	switch ( nIDEvent )
	{
	case 0:
		{
			// Ӧûصʵ;
			Sleep(3000);

			if ( GLOBAL::g_procWndInfo.bConnectStatus )
			{
				//GetDlgItem(BTN_CONNECT)->EnableWindow(FALSE);
				SetDlgItemText(BTN_CONNECT, _T("Ͽ"));
				// ťCheckFWť;
				HWND hWnd = GLOBAL::g_procWndInfo.GetButtonWnd(_T("Check FW"));
				if ( hWnd )
				{
					::PostMessage(hWnd, WM_LBUTTONDOWN, 0, 0);
					Sleep(20);
					::PostMessage(hWnd, WM_LBUTTONUP, 0, 0);
				}
			}
			else
			{
				SetDlgItemText(BTN_CONNECT, _T("豸"));
			}

			KillTimer(nIDEvent);
		}
		break;
	case 1:
		{
			if ( GLOBAL::g_procWndInfo.dwProcId )
			{

			}
		}
		break;
	default:
		break;
	}
	CDialogEx::OnTimer(nIDEvent);
}

void CPageDebug::OnOK()
{
	// TODO: ڴרô/û

	OnBnClickedTest();
}

void CPageDebug::OnCancel()
{
	// TODO: ڴרô/û

	//CDialogEx::OnCancel();
}

void CPageDebug::OnBnClickedLock()
{
	// TODO: ڴӿؼ֪ͨ
	BOOL bCheckLock = !((CButton*)GetDlgItem(CHECK_LOCK))->GetCheck();
	GetDlgItem(EDIT_BATCH_NUMBER)->EnableWindow(bCheckLock);
	if ( GLOBAL::g_config.nOffline )
	{
		GetDlgItem(COMBO_ETYPE)->EnableWindow(bCheckLock);
		GetDlgItem(EDIT_EVALUE)->EnableWindow(bCheckLock);
		GetDlgItem(SPIN_EVALUE)->EnableWindow(bCheckLock);
	}
}

void CPageDebug::OnBnClickedLoadData()
{
	// TODO: ڴӿؼ֪ͨ
}

void CPageDebug::OnCbnSelchangeEtype()
{
	// TODO: ڴӿؼ֪ͨ
	INT nCurSel = m_cbDeltaEType.GetCurSel();
	if ( nCurSel != CB_ERR )
		GLOBAL::g_config.nDeltaEType = nCurSel;
}
